<?php
/**************************************************
  Coppermine 1.5.x Plugin - html5_webm_player
  *************************************************
  Copyright (c) 2011 jisse44
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************

  $Revision: 5 $
  $LastChangedBy: jisse44 $
  $Date: 2011-07-19 $
  **************************************************/


if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$thisplugin->add_action('plugin_install','html5_webm_player_install');
$thisplugin->add_action('plugin_uninstall','html5_webm_player_uninstall');
$thisplugin->add_action('plugin_cleanup','html5_webm_player_cleanup');

$thisplugin->add_filter('html_other_media','html5_webm_player_other_media');


$thisplugin->add_filter('page_meta','html5_webm_meta');



function html5_webm_meta() {

	$return = "	<!-- Include the VideoJS Library for html5_webm_player plugin: http://videojs.com/ -->
		<script src=\"plugins/html5_webm_player/video_js/video.js\" type=\"text/javascript\" charset=\"utf-8\"></script>
	
		<script type=\"text/javascript\">
			// Add VideoJS to all video tags on the page when the DOM is ready
			VideoJS.setupAllWhenReady();
		</script>

		<!-- Include the VideoJS Stylesheet -->
		<link rel=\"stylesheet\" href=\"plugins/html5_webm_player/video_js/video_js.css\" type=\"text/css\" media=\"screen\" title=\"Video JS\" />
		";

	return $return;
}


function html5_webm_player_install() {
	global $CONFIG;

	if (mysql_result(cpg_db_query("SELECT COUNT(*) FROM {$CONFIG['TABLE_FILETYPES']} WHERE extension = 'webm'"),0) == "0") {
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_FILETYPES']} (extension,mime,content,player) VALUES ('webm','video/webm','movie','HTMLV')");
	} else {
		cpg_db_query("UPDATE {$CONFIG['TABLE_FILETYPES']} SET mime = 'video/webm', content = 'movie',player = 'HTMLV' WHERE extension = 'webm'");
	}
	if (strpos($CONFIG['allowed_mov_types'], 'webm') === FALSE) {
		cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '{$CONFIG['allowed_mov_types']}/webm' WHERE name = 'allowed_mov_types'");
	}

	return true;
}


function html5_webm_player_uninstall() {
	$superCage = Inspekt::makeSuperCage();

	if (!$superCage->post->keyExists('drop')) {
		return 1;
	}

	if (!checkFormToken()) {
		global $lang_errors;
		cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
	}

	if ($superCage->post->getInt('drop') == 1) {
		global $CONFIG;
		$allowed_mov_types = str_replace('/webm', '', $CONFIG['allowed_mov_types']);
		$allowed_mov_types = str_replace('webm/', '', $allowed_mov_types);
		$allowed_mov_types = str_replace('webm', '', $allowed_mov_types);
		cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '$allowed_mov_types' WHERE name = 'allowed_mov_types'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_FILETYPES']} WHERE extension = 'webm'");

		return true;
	}
}


function html5_webm_player_cleanup($action) {
	$superCage = Inspekt::makeSuperCage();
	$cleanup = $superCage->server->getEscaped('REQUEST_URI');
	if ($action == 1) {
		global $lang_common;
		list($timestamp, $form_token) = getFormToken();
echo <<< EOT
		    <table border="0" cellspacing="0" cellpadding="0">
			<tr>
			    <td class="tableb">
				Playback of existing webm files won't work anymore!
			    </td>
			    <td class="tableb">
				<form action="pluginmgr.php" method="post">
				    <input type="submit" name="submit" value="{$lang_common['back']}" class="button" />
				</form>
			    </td>
			    <td class="tableb">
				<form action="{$cleanup}" method="post">
				    <input type="hidden" name="drop" value="1" />
				    <input type="hidden" name="form_token" value="{$form_token}" />
				    <input type="hidden" name="timestamp" value="{$timestamp}" />
				    <input type="submit" name="submit" value="{$lang_common['continue']}" class="button" />
				</form>
			    </td>
			</tr>
		    </table>
EOT;
	}
}


function html5_webm_player_other_media($pic_html) {
	global $CURRENT_PIC_DATA;

	if ($CURRENT_PIC_DATA['extension'] == "webm") {
		global $CONFIG;

		$CURRENT_PIC_DATA['pheight'] += 20;
		$fileThumb = get_pic_url($CURRENT_PIC_DATA, 'thumb');
		$filePath = $CONFIG['ecards_more_pic_target'].get_pic_url($CURRENT_PIC_DATA, 'fullsize');

		$pic_html  = '
			<!-- Begin VideoJS -->
			<div class="video-js-box">
				<video id="movie" class="video-js" width="400" height="260" controls="controls" poster="'.$fileThumb.'">
					<source type="video/webm" src="'.$filePath.'" />
					This is HTML5 WebM video player: your browser is not compatible. Please visit <a href="http://www.webmproject.org/users/#supported_web_browsers" >WebM Official Website</a>
				</video>
			</div>
		';

	}
	return $pic_html;
}


?>
